

/**
 * The test class NESLTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class NESLTest extends junit.framework.TestCase
{
    /**
     * Default constructor for test class NESLTest
     */
    public NESLTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }
    
    public void testLoopLength ()
    {
        StringList list0 = new ESL();
        StringList list1 = new NESL("Bob", new ESL());
        StringList list2 = new NESL("Phil", list1);
        StringList list3 = new NESL("Mary", list2);
        this.assertEquals (0, list0.loopingLength());
        this.assertEquals (1, list1.loopingLength());
        this.assertEquals (2, list2.loopingLength());
        this.assertEquals (3, list3.loopingLength());
    }
    
    public void testEquals ()
    {
        StringList list0 = new ESL();
        StringList list1 = new NESL("Bob", new ESL());
        StringList list2 = new NESL("Phil", list1);
        StringList list3 = new NESL("Mary", list2);

        this.assertTrue (list0.equals(list0));
        this.assertFalse (list0.equals(new Integer(7)));
        this.assertTrue (list1.equals(list1));
        this.assertFalse (list1.equals(new NESL("Mary", new ESL())));
        this.assertTrue (list3.equals(new NESL("Mary", new NESL("Phil", new NESL("Bob", new ESL())))));
        this.assertFalse (list3.equals(new NESL("Anne", list2)));
        this.assertFalse (list3.equals(new NESL("Mary", new NESL("Phil", new ESL()))));
        this.assertFalse (list2.equals(new NESL("Phil", new NESL("Bob", new NESL("Jane", new ESL())))));
        this.assertFalse (list2.equals(new NESL("Phil", new NESL("Anne", new ESL()))));
        this.assertTrue (list3.equals(list3));
    }
}
